local CurrentRealm;
local CurrentFaction;
local CurrentChar;
local prepareready=false;
local variablesready=false;
local linktable = {};

local LDB = LibStub("LibDataBroker-1.1")
local QTip = LibStub("LibQTip-1.0")

DEFAULT_CHAT_FRAME:AddMessage("|cff3366ffProfession|cff8080ffALT|r Version 1.0 Loaded.  Type /profalt for usage.")

function ProfessionALT_OnLoad(self)
  self:RegisterEvent("TRADE_SKILL_SHOW");
  self:RegisterEvent("CHAT_MSG_WHISPER");
  self:RegisterEvent("PLAYER_ENTERING_WORLD");
  self:RegisterEvent("ADDON_LOADED");
end

SLASH_PROFALT1 = '/profalt';
function SlashCmdList.PROFALT(msg, editbox)
	if msg == 'options' then
		InterfaceOptionsFrame_OpenToCategory("ProfessionALT");
	elseif msg == '' then
		print("|cff3366ffProfession|cff8080ffALT|r Slash Command Usage:");
		print("/profalt options - Display Options Pane")
		print("/profalt list - Lists All Profession Links (Only You Can See The List)")
		print("/profalt guildlinks - Send All Profession Links To Guild Chat")
		print("/profalt <name> - Send All Profession Links To Named Player")
	elseif msg == 'guildlinks' then
		ProfessionALT_SendLink("!guildlinks", UnitName("player"))
	elseif msg == 'list' then
		ProfessionALT_SendLink("!list", UnitName("player"))
	elseif msg == 'linkbox' then
		ProfessionALT_LinkFrame()
	else
		ProfessionALT_SendLink("!altprofs", msg)
	end
end


function ProfessionALT_OnEvent()
  if(event == "CHAT_MSG_WHISPER") then
    if(arg1:sub(0,1) == "!") then
      ProfessionALT_SendLink(arg1,arg2);
    end
  elseif(event == "TRADE_SKILL_SHOW") then
    ProfessionALT_UpdateSkill();
  elseif(event == "PLAYER_ENTERING_WORLD") then
    if(prepareready == true) then
        ProfessionALT_PrepareData();
    else
        prepareready = true;
    end
    ProfessionALTFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
  elseif(event == "ADDON_LOADED") then
    if(arg1 == "ProfessionALT") then
		if not (ProfessionALT_Character) then
			ProfessionALT_Character = {};
			ProfessionALT_Character.Cooking = false;
			ProfessionALT_Character.FirstAid = false;
		end		
		variablesready = true;
		if(prepareready == true) then
			ProfessionALT_PrepareData();
		else
			prepareready = true;
		end
		ProfessionALTFrame:UnregisterEvent("ADDON_LOADED");
    end
  end
end

function ProfessionALT_SendLink(command,name)
  local _,_,requestedprof = command:find("!(%w+)");
  requestedprof = requestedprof:lower();
  if(requestedprof == "first") then
    requestedprof = "first aid";
  end
  if(linktable[requestedprof]) then
	ChatThrottleLib:SendChatMessage("NORMAL", "PRL", linktable[requestedprof].link, "WHISPER", nil, name);
  elseif (requestedprof == "profalt") then
	local profavail = "ProfessionALT - Professions Links";
	ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
	for index,value in pairs(linktable) do 
		profavail = value.name.." "..value.link;
	if (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == true) then
		if not (index == "cooking") then	
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	elseif (ProfessionALT_Character.FirstAid == false and ProfessionALT_Character.Cooking == true) then
		if not (index == "first aid") then	
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	elseif (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == false) then
		if not (index == "first aid" or index == "cooking") then	
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	else
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
	end
	end
  elseif (requestedprof == "guildlinks") then
	if (name == UnitName("player")) then
	for index,value in pairs(linktable) do 
	profavail = value.name.." "..value.link;
	if (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == true) then
		if not (index == "cooking") then	
			ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	elseif (ProfessionALT_Character.FirstAid == false and ProfessionALT_Character.Cooking == true) then
		if not (index == "first aid") then	
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	elseif (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == false) then
		if not (index == "first aid" or index == "cooking") then	
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
		end
	else
		ChatThrottleLib:SendChatMessage("NORMAL", "PRL", profavail, "WHISPER", nil, name);
	end
	end
	end
  elseif (requestedprof == "list") then
	if (name == UnitName("player")) then
		print("|cff3366ffProfession|cff8080ffALT|r - Profession Links")
		for index,value in pairs(linktable) do 
		  profavail = value.name.." "..value.link;
			if (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == true) then
				if not (index == "cooking") then	
				print(profavail)		
				end
			elseif (ProfessionALT_Character.FirstAid == false and ProfessionALT_Character.Cooking == true) then
				if not (index == "first aid") then	
				print(profavail)		
				end
			elseif (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == false) then
				if not (index == "first aid" or index == "cooking") then	
				print(profavail)		
				end
			else
				print(profavail);
			end
		end
	end
  end
end

function ProfessionALT_UpdateSkill()
  if (IsTradeSkillLinked()) then
    return;
  end
  local currentprof, currentskill = GetTradeSkillLine();
  local tradelink = GetTradeSkillListLink();
  if(tradelink == nil) then
    return;
  end
  local updateprofs = false;
  currentprof = currentprof:lower();
  if not (ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar][currentprof]) then
    ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar][currentprof] = {};
    updateprofs = true;
  else
    if(ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar][currentprof].link ~= tradelink) then
      updateprofs = true;
    end
  end
  
  if(updateprofs == true) then
    local tradecount = GetNumTradeSkills();
    local profinfo = {};
    profinfo.skill = currentskill;
    profinfo.link = tradelink;
    profinfo.counter = tradecount;
	profinfo.name = UnitName("player");
    ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar][currentprof] = profinfo;
    if not (linktable[currentprof]) then
      linktable[currentprof] = {};
      linktable[currentprof].link = tradelink;
      linktable[currentprof].skill = currentskill;
      linktable[currentprof].counter = tradecount;
	  linktable[currentprof].name = UnitName("player");
    elseif(linktable[currentprof].skill<currentskill or (linktable[currentprof].skill==currentskill and linktable[currentprof].counter < tradecount)) then
      linktable[currentprof].link = tradelink;
      linktable[currentprof].skill = currentskill;
      linktable[currentprof].counter = tradecount;
	  linktable[currentprof].name = UnitName("player");
	end
  end
end

function ProfessionALT_PrepareData()
  CurrentRealm = GetRealmName();
  CurrentFaction = UnitFactionGroup("player");	
  CurrentChar = UnitName("player");
  if not (ProfessionALT_Data) then
    ProfessionALT_Data = {};
  end
  if not (ProfessionALT_Data[CurrentRealm]) then
    ProfessionALT_Data[CurrentRealm] = {};
  end
  if not (ProfessionALT_Data[CurrentRealm][CurrentFaction]) then
    ProfessionALT_Data[CurrentRealm][CurrentFaction] = {};
  end
  if not (ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar]) then
    ProfessionALT_Data[CurrentRealm][CurrentFaction][CurrentChar] = {};
  end
  for index,value in pairs(ProfessionALT_Data[CurrentRealm][CurrentFaction]) do 
    for index2,value2 in pairs(ProfessionALT_Data[CurrentRealm][CurrentFaction][index]) do
      if not (linktable[index2]) then
        linktable[index2] = {};
		linktable[index2].link = value2.link;
		linktable[index2].skill = value2.skill;
		linktable[index2].counter = value2.counter;
		linktable[index2].name = value2.name;
      else
		if(linktable[index2].skill < value2.skill or (linktable[index2].skill == value2.skill and linktable[index2].counter < value2.counter)) then
		  linktable[index2].link = value2.link;
		  linktable[index2].skill = value2.skill;
		  linktable[index2].counter = value2.counter;
		  linktable[index2].name = value2.name;
		end
      end
    end
  end
end

function ProfessionALT_Options(panel)
panel.name = "ProfessionALT"
InterfaceOptions_AddCategory(panel);
end 

function ProfessionALT_Options_OnShow()
	if (variablesready == true) then
		ShowCooking_CheckButton:SetChecked( ProfessionALT_Character.Cooking );
		ShowFirstAid_CheckButton:SetChecked( ProfessionALT_Character.FirstAid );
	end
end

function ProfessionALT_Options_OnClick(name)
	if ( name == "Cooking" ) then
		if (ProfessionALT_Character.Cooking == true) then
			ProfessionALT_Character.Cooking = false;
		else
			ProfessionALT_Character.Cooking = true;
		end
	elseif ( name == "FirstAid" ) then
		if (ProfessionALT_Character.FirstAid == true) then
			ProfessionALT_Character.FirstAid = false;
		else
			ProfessionALT_Character.FirstAid = true;
		end
	end
end


local function ShowTooltip(anchorframe)
	if tooltip and tooltip:IsShown() then return end
	tooltip = QTip:Acquire("ProfessionALTTooltip", 1, "LEFT")
	tooltip:Clear()
	local hFont = tooltip:GetHeaderFont()
	local nFont = tooltip:GetFont()
	local hFontPath, hFontSize, nFontSize, nFontPath
	hFontPath, hFontSize, _ = hFont:GetFont()
	nFontPath, nFontSize, _ = nFont:GetFont()
	hFont:SetFont(hFontPath, hFontSize, "OUTLINE")
	nFont:SetFont(hFontPath, nFontSize, "OUTLINE")
	tooltip:SetHeaderFont(hFont)
	tooltip:SetFont(nFont)
	local headLine, headCol = tooltip:AddHeader("|cff3366ffProfession|cff8080ffALT|r")
	tooltip:AddLine()
	for index,value in pairs(linktable) do 
	  profavail = value.name.." - "..index;
		if (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == true) then
			if not (index == "cooking") then	
			tooltip:AddLine(profavail)		
			end
		elseif (ProfessionALT_Character.FirstAid == false and ProfessionALT_Character.Cooking == true) then
			if not (index == "first aid") then	
			tooltip:AddLine(profavail)		
			end
		elseif (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == false) then
			if not (index == "first aid" or index == "cooking") then	
			tooltip:AddLine(profavail)		
			end
		else
			tooltip:AddLine(profavail);
		end
	end	
	tooltip:AddLine()
	tooltip:SetAutoHideDelay(0.1, anchorframe)
	tooltip:SmartAnchorTo(anchorframe)
	tooltip:Show()
end

if LDB then
	local ldbtype
	ldbtype = "launcher"
	launcher = LDB:NewDataObject("ProfessionALT", {
		text = "ProfessionALT",
		type = ldbtype,
		icon = "Interface\\Addons\\ProfessionALT\\icon.tga",
		OnClick = function(frame, button)
			if button == "LeftButton" then
				ProfessionALT_LinkFrame()
			else
				InterfaceOptionsFrame_OpenToCategory("ProfessionALT")
			end
		end,
		OnEnter = function(self)
			ShowTooltip(self)
		end,
		})
end

function ProfessionALT_LinkFrame()
	if (ProfessionALT_LinkFrameDisplay == "Show") then
		ProfessionALT_LinkFrameDisplay = "Hide"
		
        point, relativeTo, relativePoint, xOfs, yOfs = ProfessionALT_LinkDisplayFrame:GetPoint()
		ProfessionALT_Character.point1 = point
		ProfessionALT_Character.point2 = xOfs
		ProfessionALT_Character.point3 = yOfs
		ProfessionALT_LinkDisplayFrame:Hide()
		ProfessionALT_LinkDisplayFrame:SetParent(nil)
		ProfessionALT_LinkDisplayFrame = nil
	else
		ProfessionALT_LinkFrameDisplay = "Show"
			local f=CreateFrame("FRAME","ProfessionALT_LinkDisplayFrame",UIParent);
			f:SetMovable(true)
			f:EnableMouse(true)
			f:RegisterForDrag("RightButton")
			f:SetScript("OnDragStart", ProfessionALT_LinkDisplayFrame.StartMoving)
			f:SetScript("OnDragStop", ProfessionALT_LinkDisplayFrame.StopMovingOrSizing)
			f:SetWidth(110); f:SetHeight(15);
			if ProfessionALT_Character.point1 then
				f:SetPoint(ProfessionALT_Character.point1, UIParent, ProfessionALT_Character.point2, ProfessionALT_Character.point3);
			else
			f:SetPoint("CENTER",UIParent);
			end
			f:SetBackdrop({
			  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
			  edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", 
			  tile=1, tileSize=10, edgeSize=10, 
			  insets={left=3, right=3, top=3, bottom=3}
			});
			local fs = f:CreateFontString("$parentText","Title","TextStatusBarText");
			fs:SetPoint("TOPLEFT", 3, -3);
			fs:SetText("|cff3366ffProfession|cff8080ffALT|r Links");
			local cnt = 1
			for index,value in pairs(linktable) do 
				local cntx = cnt * 10
				profavail = value.link;
				proflink = value.name..value.link;
				proflinkname = "'"..value.name..value.link.."'";
				if (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == true) then
					if not (index == "cooking") then	
					local f2=CreateFrame("FRAME",proflinkname,f);
					local fs2 = f2:CreateFontString("$parentText","Title","TextStatusBarText");
					f2:SetMovable(true);
					f2:EnableMouse(true);
					f2:SetScript("OnMouseUp", function() print("|cff3366ffProfession|cff8080ffALT|r: "..fs2:GetText()) end);
					f2:SetWidth(110); f2:SetHeight(13);
					f2:SetPoint("BOTTOM",f, 0, cntx-3);
					f:SetHeight(cntx+24);
					fs2:SetPoint("BOTTOMLEFT", 3,0);
					fs2:SetText(profavail);
					cnt = cnt + 1
					end
				elseif (ProfessionALT_Character.FirstAid == false and ProfessionALT_Character.Cooking == true) then
					if not (index == "first aid") then	
					local f2=CreateFrame("FRAME",proflinkname,f);
					local fs2 = f2:CreateFontString("$parentText","Title","TextStatusBarText");
					f2:SetMovable(true);
					f2:EnableMouse(true);
					f2:SetScript("OnMouseUp", function() print("|cff3366ffProfession|cff8080ffALT|r: "..fs2:GetText()) end);
					f2:SetWidth(110); f2:SetHeight(13);
					f2:SetPoint("BOTTOM",f, 0, cntx-3);
					f:SetHeight(cntx+24);
					fs2:SetPoint("BOTTOMLEFT", 3,0);
					fs2:SetText(profavail);
					cnt = cnt + 1
					end
				elseif (ProfessionALT_Character.Cooking == false and ProfessionALT_Character.FirstAid == false) then
					if not (index == "first aid" or index == "cooking") then	
					local f2=CreateFrame("FRAME",proflinkname,f);
					local fs2 = f2:CreateFontString("$parentText","Title","TextStatusBarText");
					f2:SetMovable(true);
					f2:EnableMouse(true);
					f2:SetScript("OnMouseUp", function() print("|cff3366ffProfession|cff8080ffALT|r: "..fs2:GetText()) end);
					f2:SetWidth(110); f2:SetHeight(13);
					f2:SetPoint("BOTTOM",f, 0, cntx-3);
					f:SetHeight(cntx+24);
					fs2:SetPoint("BOTTOMLEFT", 3,0);
					fs2:SetText(profavail);
					cnt = cnt + 1
					end
				else
					local f2=CreateFrame("FRAME",proflinkname,f);
					local fs2 = f2:CreateFontString("$parentText","Title","TextStatusBarText");
					f2:SetMovable(true);
					f2:EnableMouse(true);
					f2:SetScript("OnMouseUp", function() print("|cff3366ffProfession|cff8080ffALT|r: "..fs2:GetText()) end);
					f2:SetWidth(110); f2:SetHeight(13);
					f2:SetPoint("BOTTOM",f, 0, cntx-3);
					f:SetHeight(cntx+24);

					fs2:SetPoint("BOTTOMLEFT", 3,0);
					fs2:SetText(profavail);
					cnt = cnt + 1
				end
			end	
		ProfessionALT_LinkDisplayFrame:Show()
	end
end
